'use strict';

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _d3StateVisualizer = require('d3-state-visualizer');

var _d3StateVisualizer2 = _interopRequireDefault(_d3StateVisualizer);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Chart = function (_Component) {
  _inherits(Chart, _Component);

  function Chart(props) {
    _classCallCheck(this, Chart);

    return _possibleConstructorReturn(this, _Component.call(this, props));
  }

  Chart.prototype.componentDidMount = function componentDidMount() {
    this.renderChart = _d3StateVisualizer2.default.charts.tree((0, _reactDom.findDOMNode)(this), this.props);
    this.renderChart();
  };

  Chart.prototype.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
    var state = nextProps.state;

    this.renderChart(state);
  };

  Chart.prototype.render = function render() {
    return _react2.default.createElement('div', null);
  };

  return Chart;
}(_react.Component);

Chart.propTypes = {
  state: _react.PropTypes.object,
  rootKeyName: _react2.default.PropTypes.string,
  pushMethod: _react2.default.PropTypes.string,
  tree: _react.PropTypes.shape({
    name: _react.PropTypes.string,
    children: _react.PropTypes.array
  }),
  id: _react.PropTypes.string,
  style: _react.PropTypes.object,
  size: _react.PropTypes.number,
  aspectRatio: _react.PropTypes.number,
  isSorted: _react2.default.PropTypes.bool,
  heightBetweenNodesCoeff: _react2.default.PropTypes.number,
  widthBetweenNodesCoeff: _react2.default.PropTypes.number,
  transitionDuration: _react2.default.PropTypes.number,
  tooltipOptions: _react.PropTypes.shape({
    left: _react.PropTypes.number,
    top: _react.PropTypes.number,
    offset: _react.PropTypes.shape({
      left: _react.PropTypes.number,
      top: _react.PropTypes.number
    }),
    indentationSize: _react.PropTypes.number
  })
};
exports.default = Chart;